unit uWMCopyDataReceiver;

{******************************************************************************
Initial Author   :    Scott Price
Initially Created:    06-Apr-2003
Language         :    Object Pascal
Compiler Version :    Delphi 3.02, 4.03, 5.01, 6.02 (UK)
Copyright        :     Information Technology Sector Limited, 1996-2002

Source Code Constraints:
========================
   Distribution, disclosure or modifications of this source code, outside of
   any licenced agreements with Information Technology Sector Limited, or
   removal of this notice constitutes a breach of any or all license agreements.

Operating Systems Tested On:
============================
   Microsoft Windows(R) 98, First Edition
   Microsoft Windows(R) 2000, Service Pack 2

Design Notes:
=============

VERSION  AUTHOR                DATE/TIME
===============================================================================
$history$
$nokeywords$
===============================================================================
NOTES:
===============================================================================
TODO:
******************************************************************************}


interface



uses
  { Borland Standard Units }
{$IFDEF VER140}
  Variants,
{$ENDIF}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;



type
  { TfmWMCopyDataReceiver }

  TfmWMCopyDataReceiver = class(TForm)
    btnReceiver: TButton;
  private
    { Private declarations }
    procedure WMCopyData(var Msg: TWMCopyData); message WM_COPYDATA;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;


var
  fmWMCopyDataReceiver: TfmWMCopyDataReceiver;



implementation

{$R *.dfm}

{ TfmWMCopyDataReceiver }

constructor TfmWMCopyDataReceiver.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  { TODO:  Any Requireds }
end;

destructor TfmWMCopyDataReceiver.Destroy;
begin
  TRY
    { TODO:  Any Clean Up }
  FINALLY
    inherited Destroy;
  END;
end;

procedure TfmWMCopyDataReceiver.WMCopyData(var Msg: TWMCopyData);
var
  msIn: TMemoryStream;
begin
  { IMPORTANT:  The copy data pointer is only valid for this method, so if we
                want to keep this data, we need to make a local copy. }
  if Msg.CopyDataStruct <> nil then
  begin
    msIn := TMemoryStream.Create;
    TRY
      { Get the Size and Set the Stream Size }
      msIn.Size := Msg.CopyDataStruct^.cbData;
      msIn.Position := 0;

      { Copy the data from the record to the Stream }
      Move(Msg.CopyDataStruct^.lpData^, msIn.Memory^, Msg.CopyDataStruct^.cbData);
      msIn.Position := 0;

      { Read in the Component }
      msIn.ReadComponent(btnReceiver);
    FINALLY
      FreeAndNil(msIn);
    END;
  end;
end;

end.
